## TODO:
* test RenderHelper.disableStandardItemLighting();
* add no harm to legs potion effect after Tarzan Jump
* add stun effect for pudge hook
* fix hook jitter when switching from shooting to reeling
* fix rope jitter when reeling too fast
* dismount shooter when rope tension > shooter's weight
* fix blocking with a shield in the offhand and a hook in the mainhand  
* add launch cooldown after detaching due to exceeding the weight limit
* add hookWeight parameter to control hook gravity and knockStrength
* add a description for attachment capabilities
* add reeling options: manual, auto, auto_jump, auto_detach
* add rope and motor strength
* implement Wall jump
* add sounds for all actions
* reeling speed based on motor strength and tension force
* fix movement on boats
* fix synchronization issues due to some calculations done on the server instead of the client side (grasp_)
* improve swing momentum (waldotheranger, AnbuGrizz, catomax26)
* add settings to configure the type of interaction with a specific block (EpicDRC, simrani_p, Anddrond)
* add an option to switch to arcade mode (no gravity, no swinging and auto-pulling)
* allow pudge hook to be attached to a block if there is a free space above
* implement proper datagen for recipes

## 10.1.0.1
* fixed: incorrect detection of conflicting keybinds
* fixed: keybinds not working after Forge 47.2.10 update (thanks to amazing_mirzakhani3455475)
* __requires: ForgeEndertech 11.1.0.0 or above__

## 10.1.0.0
* updated to Minecraft 1.20.1
* __requires: ForgeEndertech 11.1.0.0 or above__

## 10.0.0.0
* updated to Minecraft 1.20
* __requires: ForgeEndertech 11.0.0.0 or above__

## 9.2.0.0
* updated to Minecraft 1.19.4
* __requires: ForgeEndertech 10.2.0.0 or above__

## 9.1.0.0
* updated to Minecraft 1.19.3
* __requires: ForgeEndertech 10.1.0.0 or above__

## 9.0.3.0
* updated to Minecraft 1.19.2
* __requires: ForgeEndertech 10.0.4.0 or above__

## 9.0.2.0
* updated to breaking changes in Forge 41.0.94
* __requires: ForgeEndertech 10.0.3.0 or above__

## 9.0.1.0
* updated to and requires Forge 41.0.64+
* __requires: ForgeEndertech 10.0.2.0 or above__

## 9.0.0.0
* updated to Minecraft 1.19
* __requires: ForgeEndertech 10.0.0.0 or above__

## 8.0.0.0
* updated to Minecraft 1.18.2
* __requires: ForgeEndertech 9.0.0.0 or above__

## 7.0.0.1
* fixed: being able to use Tarzan Jump even when the hook is not attached to the surface (thanks to yeetoburreeto and GeradesoLukas)
* __requires: ForgeEndertech 8.0.0.0 or above__

## 7.0.0.0
* updated to Minecraft 1.18.1
* __requires: ForgeEndertech 8.0.0.0 or above__

## 6.1.8.1
* fixed: being unable to launch a hook while looking at a block within reach distance (thanks to shendrift)

## 6.1.8.0
+ implemented: proper Tarzan Jump with horizontal boost (thanks to catomax26)
* renamed: old Tarzan Jump with vertical boost to Jump Boost
* fixed: conflicting keybinds
* fixed: launcher tooltips
* __requires: ForgeEndertech 7.2.1.0 or above__

## 6.1.7.0
+ added: ability to jump onto the trees using a Pudge Hook
+ added: ability to hook leaves, fences, iron bars and poles with the Pudge Hook
+ added: ability to rip out torches, bells and lanterns with the Pudge Hook
+ added: ability to cut grass and plants when retracting the Pudge Hook
+ added: new 'breaksGlass' and 'affectsItems' settings (thanks to EpicDRC)
* decreased: Tarzan jump strength for the Pudge Hook Launcher (delete old config/adhooks/launchers/pudge.cfg)
* fixed: boosted movement in water and jumping when swinging
* fixed: synchronization of hooked items movement
* __requires: ForgeEndertech 7.2.0.0 or above__

## 6.1.6.0
* updated to Forge 36.2.0
* migrated to Mojang mappings
* fixed: Spear Hook not attaching to trees
* __requires: ForgeEndertech 7.2.0.0 or above__

## 6.1.5.0
+ added: config option to adjust hook launch velocity (thanks to EpicDRC)
* increased: render distance
* done: lots of refactorings
* fixed: rope disappearing in third person view (thanks to rngmemedawg and catomax26)

## 6.1.4.0
+ added: ability to hook dropped items
+ added: 'shooterWeightFactor' parameter to control player's weight advantage/disadvantage over the hooked target (thanks to EpicDRC)
* increased: player's weight advantage when using Pudge Hook to avoid excessive pulling towards the hooked mob (thanks to catomax26)
* increased: entity hitboxes for easier hitting the target
* fixed: hooks being attached to grass and plants
* __requires: ForgeEndertech 7.1.0.0 or above__

## 6.1.3.1
* fixed: conflicting Attack keybind (thanks to Retrodaniel)
* __requires: ForgeEndertech 7.0.10.0 or above__

## 6.1.3.0
+ implemented: rebindable controls (thanks to waldotheranger and hairlessOrphan)
* improved: launcher control tooltips
* fixed: hook relaunch cooldown not resetting correctly after releasing the key
* __requires: ForgeEndertech 7.0.10.0 or above__

## 6.1.2.0
* updated to Minecraft 1.16.4
* __requires: ForgeEndertech 7.0.7.0 or above__

## 6.1.1.0
* updated to Minecraft 1.16.3
* fixed: hook not detaching when its launcher being dropped
* fixed: an issue with getting two hooks attached to one launcher (thanks to waldotheranger)
* fixed: launching the off-hand hook when placing a block
* __requires: ForgeEndertech 7.0.4.0 or above__

## 6.1.0.0
+ implemented: ability to control launcher in the off hand (thanks to the\_awoken\_kami)  
+ implemented: ability to control launchers in both hands simultaneously (thanks to waldotheranger)
* updated: launcher control tooltips
* reworked: default controls (see launcher tooltips)
* replaced: "boostStrength" parameter with "tarzanJumpStrength"
* fixed: rope position depending on the hand the launcher is in
* __requires: ForgeEndertech 7.0.3.0 or above__

## 6.0.1.0
* updated to Minecraft 1.16.2
* __requires: ForgeEndertech 7.0.2.0 or above__

## 6.0.0.0
* ported to Minecraft 1.16.1
* __requires: ForgeEndertech 7.0.0.0 or above__

## 5.1.0.0
+ implemented: ability to swing (thanks to Qsandas, ZoraergazU and waldotheranger)
+ implemented: synchronization of custom parameters with clients
+ implemented: new rope renderer compatible with Optifine
+ added: Chinese translation (thanks to beardpico)
* reworked: network code and movement synchronization
* reduced: network bandwidth usage by removing excessive motion updates
* fixed: rubber band effect (spontaneous bouncing up and down) (thanks to MischiefOfMice)
* fixed: a crash when trying to configure the mod through the game menu (thanks to Andy563563 and MPWHart)
* fixed: very slow movement when dragging another entity, even a small one
* fixed: incorrect lighting of a hook shot
* __requires: ForgeEndertech 6.0.4.0 or above__

## 5.0.0.0
* ported to Minecraft 1.15.2
* __requires: ForgeEndertech 6.0.0.0 or above__

## 4.0.0.2
* fixed: a critical bug with network messages that broke the mod in multiplayer
* __requires: ForgeEndertech 5.2.0.0 or above__

## 4.0.0.1
* fixed: incorrect dependencies in mods.toml
* __requires: ForgeEndertech 5.1.0.0 or above__

## 4.0.0.0
* ported to Minecraft 1.14.4
* __requires: ForgeEndertech 5.0.0.0 or above__

## 3.2.2.0
+ implemented: localizable tooltips (thanks to mc_china)
* fixed: some errors in tooltips
* __requires: ForgeEndertech 4.4.2.0 or above__

## 3.2.1.0
+ implemented: different behavior when interacting with blocks depending on their material
	(breaking glass, passing through leaves, inability to spear hard material, etc.)
+ added: "canHookAnyBlock" config option to enable old hook behavior
* fixed: hook and rope rendering in black, where possible
* __requires: ForgeEndertech 4.3.19.0 or above__

## 3.2.0.0
+ added: new voxel models for all hooks and launchers
- removed: xp penalty when renewing string for the same launcher more than once 
* improved: recipes for all launchers (please delete old configs)
* __requires: ForgeEndertech 4.3.18.0 or above__

## 3.1.3.0
+ added: config options to disable the ability to pull entities/players (thanks to purendar2)
* __requires: ForgeEndertech 4.3.8.0 or above__

## 3.1.2.1
* moved: web recipe from config to json preventing log warnings

## 3.1.2.0
! ATTENTION: delete old configs (.minecraft/config/adhooks folder) for changes to take effect
* increased: strength of all hooks
* moved: unhook keybinding from configs to Controls/Gameplay menu
* fixed: key processing being not synchronized with a main thread which may cause hook not being launched
* fixed: pudge hook loosening
* fixed: rope length exceeding the allowable bounds when pulling
* improved: physics and dynamics
* fixed: not working fast reeling when holding pull button

## 3.1.1.0
! ATTENTION: delete old configs (.minecraft/config/adhooks folder) for changes to take effect 
* increased: durability for all hooks
* increased: rope length for all hooks
* increased: rope elasticity for spear hook launcher
* reduced: reeling speed for spear hook launcher

## 3.1.0.0
* fixed: invalid event annotation error (thanks to Yayes)
* updated to recommended forge-1.12.2-14.23.0.2491

## 3.0.0.0
* ported to Minecraft 1.12

## 2.0.5.0
+ added config parameter for defining a custom key for the Unhook action (thanks to thefirstgamemaster)

## 2.0.4.0
+ added: pudge hook now dismounts riding entities
* improved: weight calculations for better physics
* improved: boost up strength (delete old configs)
* fixed: boost up not working everytime 
* fixed: pudge hook getting stuck on immovable entities
* fixed: rope jerking motion when hooking an entity
* fixed: id remap not working when updating from old versions

## 2.0.3.0
+ added config parameter for hook fire resistance
* hooks are flammable now

## 2.0.2.0
* deep code reorganization
* updated to the latest recommended forge-1.11.2-13.20.0.2228

## 2.0.1.1
* fixed accidental startup crash with NullPointerException

## 2.0.1.0
* fixed recipes may not being initialized
* some code improvements
* updated to the latest forge-1.11.2-13.20.0.2223

## 2.0.0.0
* ported to Minecraft 1.11.2 (forge-1.11.2-13.20.0.2203)
* changed format for all ids to comply with MC 1.11 standart

## 1.0.2.4
* fixed asynchronous hook creation which might cause server crashes with:
* ConcurrentModificationException (thanks to RunicGlympse)

## 1.0.2.3
* fixed: rendering glitch with multiple hooks launched

## 1.0.2.2
* fixed occasional server crashes with:
* java.util.ConcurrentModificationException (thanks to Hastling)

## 1.0.2.1
* fixed dedicated server crash with:
* java.lang.NoSuchMethodError: toModelResLoc_Inventory() (thanks to Vazkii)

## 1.0.2.0
* added new ability: "Boost up" (see launcher control tooltip)
* increased Spear Hook Launcher default reeling speed to 0.6
* requires ForgeEndertech 1.10.2-1.1.3.0

## 1.0.1.0
* added more informative tooltips
* fixed incorrect durability settings
* requires ForgeEndertech 1.10.2-1.1.2.0

## 1.0.0.2
* fixed dedicated server crash with:
* java.lang.NoClassDefFoundError: net/minecraft/client/renderer/entity/Render

## 1.0.0.1
* rebuild to accept older Minecraft versions [1.9.4, 1.10]
* requires ForgeEndertech 1.10.2-1.1.1.1

## 1.0.0.0
* ported to Minecraft 1.10.2
* fixed rope jerks when hooking some entity
* fixed hook rotation glitches when reeling begins
* fixed rope sagging glitch when hooking blocks
* requires ForgeEndertech 1.10.2-1.1.1.0

